{$N+}
unit stats;
interface


var sx,sy,sx2,sy2,sxy,xbar,ybar,sigx,sigy,corr,regression,intercept: real;

procedure correl(ty: char; x,y: pointer ; datasize: integer);

implementation

type dataarraytype = array[0..2047] of integer;
     rdataarraytype = array[0..2047] of real;
     dataptrtype = ^dataarraytype;
     rdataptrtype = ^rdataarraytype;

procedure correl;
var n,u,v,w,z: real;
    i: integer;
    dxptr,dyptr:  dataptrtype;
    rdxptr,rdyptr:  rdataptrtype;
begin
 if ty = 'i' then
 begin
  dxptr := x; dyptr := y;
 end
 else
 begin
  rdxptr := x; rdyptr := y;
 end;
 sx := 0.0; sy := 0.0;
 n := datasize;
 for i := 0 to datasize - 1 do
  begin
   if ty = 'i' then
   begin
    u := dxptr^[i]; v := dyptr^[i];
   end
   else
   begin
    u := rdxptr^[i]; v := rdyptr^[i];
   end;
   sx := sx + u; sy := sy + v;
  end;
 xbar := sx/n; ybar := sy/n;
 sx2 := 0.0; sy2 := 0.0; sxy := 0.0;
 for i := 0 to datasize - 1 do
  begin
   if ty = 'i' then
   begin
    u := dxptr^[i]; v := dyptr^[i];
   end
   else
   begin
    u := rdxptr^[i]; v := rdyptr^[i];
   end;
   sx2 := sx2 + (u - xbar)*(u - xbar);
   sy2 := sy2 + (v - ybar)*(v - ybar);
   sxy := sxy + (u - xbar)*(v - ybar);
  end;
 sigx :=sqrt(sx2/n);
 sigy :=sqrt(sy2/n);
 if (abs(sigx*sigy) > 0.0001) then
  z := sxy/(n * sigx * sigy)
 else z := 0.0;
 corr := z;
 if abs(sigx) > 0.001 then regression := z * sigy/sigx
 else regression := 9999.99;
 intercept := ybar - regression*xbar;
end;

end.